package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.pay.domain.PayAisle;
import com.zhongzheng.modules.pay.domain.PayServe;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PaySourceAddBo;
import com.zhongzheng.modules.pay.bo.PaySourceQueryBo;
import com.zhongzheng.modules.pay.bo.PaySourceEditBo;
import com.zhongzheng.modules.pay.domain.PaySource;
import com.zhongzheng.modules.pay.mapper.PaySourceMapper;
import com.zhongzheng.modules.pay.vo.PaySourceVo;
import com.zhongzheng.modules.pay.service.IPaySourceService;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 渠道来源Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PaySourceServiceImpl extends ServiceImpl<PaySourceMapper, PaySource> implements IPaySourceService {

    @Override
    public PaySourceVo queryById(Long sourceId){
        PaySource db = this.baseMapper.selectById(sourceId);
        return BeanUtil.toBean(db, PaySourceVo.class);
    }

    @Override
    public List<PaySourceVo> queryList(PaySourceQueryBo bo) {
        LambdaQueryWrapper<PaySource> lqw = Wrappers.lambdaQuery();
        lqw.in(bo.getStatus() != null, PaySource::getStatus, bo.getStatus());
        lqw.like(StrUtil.isNotBlank(bo.getSourceName()), PaySource::getSourceName, bo.getSourceName());
        lqw.orderByDesc(PaySource::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PaySourceVo> entity2Vo(Collection<PaySource> collection) {
        List<PaySourceVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PaySourceVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PaySource> page = (Page<PaySource>)collection;
            Page<PaySourceVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PaySourceAddBo bo) {
        PaySource add = BeanUtil.toBean(bo, PaySource.class);
        LambdaQueryWrapper<PaySource> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getSourceName()), PaySource::getSourceName, bo.getSourceName());
        List<Integer> status = new ArrayList<>();
        status.add(1);
        status.add(0);
        lqw.in(bo.getStatus() != null, PaySource::getStatus, status);
        List<PaySource> list = this.list(lqw);
        if (CollectionUtils.isNotEmpty(list)){
            throw new RuntimeException("重复渠道来源名字");
        }
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PaySourceEditBo bo) {
        PaySource update = BeanUtil.toBean(bo, PaySource.class);
        LambdaQueryWrapper<PaySource> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getSourceName()), PaySource::getSourceName, bo.getSourceName());
        lqw.like(bo.getSourceId()!= null, PaySource::getSourceId, bo.getSourceId());
        List<PaySource> list = this.list(lqw);
        if (CollectionUtils.isEmpty(list)){
            lqw.clear();
            lqw.eq(StrUtil.isNotBlank(bo.getSourceName()), PaySource::getSourceName, bo.getSourceName());
            List<Integer> status = new ArrayList<>();
            status.add(1);
            status.add(0);
            lqw.in(bo.getStatus() != null, PaySource::getStatus, status);
            List<PaySource> list1 = this.list(lqw);
            if (CollectionUtils.isNotEmpty(list1)){
                throw new IllegalArgumentException("重复渠道来源名字");
            }
        }
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PaySource entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
